import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
public class OvalOrbitFleet extends Applet implements Runnable{
    Thread t;
    XCanvas xc;
    ImgFrame imgfr;
    boolean running=true;
    Image rand;
    Image boden;
    Image xpo;
    Image xpo2;
    Image obj;
    int keycode=0;
    static OvalOrbitFleet app;
    public void init(){
        app=this;
        resize(660,480);
        setLayout(null);
        imgfr=new ImgFrame();
        rand=getImage("rand.gif");
        boden=getImage("boden.gif");
        xpo=getImage("xpo.gif");
        xpo2=getImage("xpo2.gif");
        obj=getImage("obj.gif");
        MediaTracker tracker=new MediaTracker(this);
        tracker.addImage(xpo,0);
        tracker.addImage(xpo2,0);
        tracker.addImage(boden,0);
        tracker.addImage(rand,0);
        tracker.addImage(obj,0);
        try{
            tracker.waitForID(0);
        }
        catch(Exception e){}
        xc=new XCanvas(this);
        add(xc);
        xc.reshape(10,30,640,440);
        show();
        requestFocus();
        t=new Thread(this);
        t.start();
    }
    public static Image getImage(String filename){
        try{
            URL url=OvalOrbitFleet.app.getClass().getResource("/"+filename);
            Image img=OvalOrbitFleet.app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void run(){
        xc.hide();
        KeyboardMapperApplet km=new KeyboardMapperApplet(this);
        add(km);
        km.reshape(0,40,400,400);
        km.show();
        while(!km.closed){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
        xc.show();
        requestFocus();
        while(running){
            try{
                for(int i=0;i<10;i++){
                    Thread.sleep(10);
                    if(keycode!=0){
                        if(!km.applyb){
                            xc.process(keycode);
                        }
                        else{
                            xc.process(km.getKeyCode(keycode));
                        }
                    }
                    keycode=0;
                }
                xc.step();
                xc.repaint();
            }
            catch(Exception e){
                e.printStackTrace();
            }
        }
    }
    public static void main(String[]args){
        new OvalOrbitFleet();
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY){
            System.exit(0);
        }
        if(evt.id==Event.KEY_ACTION||evt.id==Event.KEY_PRESS){
            keycode=evt.key;
        }
        return false;
    }
}
class XCanvas extends Canvas{
    OvalOrbitFleet oo;
    Enemy[]enemies=new Enemy[50];
    Kugel[]kugeln=new Kugel[200];
    int encount=1000;
    double alpha=0;
    double beta1=Math.PI;
    double beta2=0;
    boolean addkuga=false;
    boolean addkugb=false;
    long gamestart;
    long gameend;
    int[]starsx=new int[100];
    int[]starsy=new int[100];
    int enemiesonscreen=0;
    int enemiesthrough=0;
    int enemiesdestroyed=0;
    public XCanvas(OvalOrbitFleet oo){
        this.oo=oo;
        for(int i=0;i<100;i++){
            starsx[i]=(int)(Math.random()*320.0);
            starsy[i]=(int)(Math.random()*400.0);
        }
        gamestart=System.currentTimeMillis();
    }
    public void addEnemy(){
        int random=(int)(Math.random()*10);
        if(random!=0){
            return;
        }
        if(enemiesonscreen>=encount){
            return;
        }
        int pos=(int)(Math.random()*50.0);
        if(enemies[pos]==null){
            double xv=(double)((int)(Math.random()*320+160.0));
            double yv=-20.0;
            double xvd=0.0;
            double yvd=(Math.random()*4.0)+4.0;
            enemies[pos]=new Enemy(xv,yv,xvd,yvd);
            enemiesonscreen=enemiesonscreen+1;
        }
    }
    public void newGame(){
        for(int i=0;i<50;i++){
            enemies[i]=null;
        }
        gamestart=System.currentTimeMillis();
        for(int i=0;i<200;i++){
            kugeln[i]=null;
        }
        encount=1000;
        enemiesonscreen=0;
        enemiesdestroyed=0;
        enemiesthrough=0;
        alpha=0;
        beta1=Math.PI;
        beta2=0;
        addkuga=false;
        addkugb=false;
    }
    public synchronized void process(int key){
            if(key==Event.LEFT){
                beta1=beta1-Math.PI/90;
            }
            if(key==Event.RIGHT){
                beta1=beta1+Math.PI/90;
            }
            if(key==Event.ENTER){
                addkuga=true;
            }
            if(key==121){
                beta2=beta2-Math.PI/90;
            }
            if(key==120){
                beta2=beta2+Math.PI/90;
            }
            if(key==115){
                addkugb=true;
            }
            if(key==Event.ESCAPE){
                newGame();
            }
    }
    public synchronized void step(){
        alpha=alpha+(Math.PI*2/720.0);
        if(addkuga){
            addkuga=false;
            double xva=Math.cos(alpha)*290.0+320.0;
            double yva=Math.sin(alpha)*170.0+200.0;
            double xdva=Math.cos(beta1)*7.0;
            double ydva=Math.sin(beta1)*7.0;
            addkugel(xva,yva,xdva,ydva);
        }
        if(addkugb){
            addkugb=false;
            double xva=Math.cos(alpha+Math.PI)*290.0+320.0;
            double yva=Math.sin(alpha+Math.PI)*170.0+200.0;
            double xdva=Math.cos(beta2)*7.0;
            double ydva=Math.sin(beta2)*7.0;
            addkugel(xva,yva,xdva,ydva);
        }
        addEnemy();
        for(int i=0;i<200;i++){
            if(kugeln[i]!=null){
                kugeln[i].x=kugeln[i].x+kugeln[i].xd;
                kugeln[i].y=kugeln[i].y+kugeln[i].yd;
                if(kugeln[i].x<20||kugeln[i].y<20||kugeln[i].x>=620||kugeln[i].y>=380){
                    kugeln[i]=null;
                }
            }
        }
        for(int i=0;i<50;i++){
            if(enemies[i]!=null){
                enemies[i].x=enemies[i].x+enemies[i].xd;
                enemies[i].y=enemies[i].y+enemies[i].yd;
                if(enemies[i].x<20||enemies[i].x>=620){
                    enemies[i].xd=-enemies[i].xd;
                }
                if(enemies[i].y>=400){
                    enemies[i]=null;
                    encount--;
                    enemiesonscreen--;
                    enemiesthrough++;
                }
                for(int j=0;j<200;j++){
                    if(kugeln[j]!=null&&enemies[i]!=null){
                        if((kugeln[j].x>=enemies[i].x-10)&&(kugeln[j].y>=enemies[i].y-10)&&(kugeln[j].x<enemies[i].x+10)&&(kugeln[j].y<enemies[i].y+10)){
                            enemies[i]=null;
                            encount--;
                            enemiesdestroyed++;
                            enemiesonscreen--;
                        }
                    }
                }
            }
        }
    }
    public void paint(Graphics g){
    }
    public synchronized void update(Graphics g){
        Graphics h=oo.imgfr.img.getGraphics();
        h.setColor(Color.white);
        h.fillRect(0,0,640,440);
        for(int i=0;i<32;i++){
            if(i<8||i>=24){
                h.drawImage(oo.rand,i*20,0,this);
                h.drawImage(oo.rand,i*20,380,this);
            }
        }
        for(int i=1;i<19;i++){
            h.drawImage(oo.rand,0,i*20,this);
            h.drawImage(oo.rand,620,i*20,this);
        }
        for(int i=1;i<31;i++){
            for(int j=1;j<19;j++){
                if(i<8||i>=24){
                    h.drawImage(oo.boden,i*20,j*20,this);
                }
            }
        }
        h.setColor(Color.black);
        h.fillRect(160,0,320,400);
        h.setColor(Color.white);
        for(int i=0;i<100;i++){
            h.drawRect(160+starsx[i],starsy[i],1,1);
        }
        for(int i=0;i<50;i++){
            if(enemies[i]!=null){
                h.drawImage(oo.obj,(int)(enemies[i].x-10),(int)(enemies[i].y-10),this);
            }
        }
        for(int i=0;i<200;i++){
            if(kugeln[i]!=null){
                h.fillOval((int)(kugeln[i].x-4),(int)(kugeln[i].y-4),8,8);
            }
        }
        int xvai=(int)(Math.cos(alpha)*290.0+320.0);
        int yvai=(int)(Math.sin(alpha)*170.0+200.0);
        h.drawImage(oo.xpo,xvai-10,yvai-10,this);
        int xvdai=(int)(Math.cos(beta1)*15.0);
        int yvdai=(int)(Math.sin(beta1)*15.0);
        h.drawLine(xvai,yvai,xvai+xvdai,yvai+yvdai);
        int xvbi=(int)(Math.cos(alpha+Math.PI)*290.0+320.0);
        int yvbi=(int)(Math.sin(alpha+Math.PI)*170.0+200.0);
        h.drawImage(oo.xpo2,xvbi-10,yvbi-10,this);
        int xvdbi=(int)(Math.cos(beta2)*15.0);
        int yvdbi=(int)(Math.sin(beta2)*15.0);
        h.drawLine(xvbi,yvbi,xvbi+xvdbi,yvbi+yvdbi);
        h.setColor(Color.black);
        long gamepos=System.currentTimeMillis();
        if(encount>0){
            gameend=(gamepos-gamestart)/100;
        }
        String pstr="Enemies left: "+encount+" Destroyed: "+enemiesdestroyed+" Through: "+enemiesthrough+" Time: "+gameend;
        h.drawString(pstr,10,420);
        g.drawImage(oo.imgfr.img,0,0,this);
    }
    public void addkugel(double xv,double yv,double xvd,double yvd){
        int k=0;
        while(k<200&&kugeln[k]!=null){
            k++;
        }
        if(k<200&&kugeln[k]==null){
            kugeln[k]=new Kugel(xv,yv,xvd,yvd);
        }
    }
}
class Kugel{
    double x;
    double y;
    double xd;
    double yd;
    public Kugel(double x,double y,double xd,double yd){
        this.x=x;
        this.y=y;
        this.xd=xd;
        this.yd=yd;
    }
}
class Enemy{
    double x;
    double y;
    double xd;
    double yd;
    public Enemy(double x,double y,double xd,double yd){
        this.x=x;
        this.y=y;
        this.xd=xd;
        this.yd=yd;
    }
}
class ImgFrame extends Frame{
    Image img;
    public ImgFrame(){
        pack();
        img=createImage(640,440);
    }
}
class KeyboardMapperApplet extends Panel{
    Label info;
    List l;
    Label aliasl;
    TextField aliastf;
    Label keyl;
    TextField keytf;
    Button add;
    Button remove;
    Button addspecial;
    Button apply;
    Button cancel;
    Button dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    String[]alias=new String[0];
    String[]key=new String[0];
    boolean[]special=new boolean[0];
    Applet applet;
    public KeyboardMapperApplet(Applet applet){
        resize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new Label("");
        l=new List();
        aliasl=new Label("alias key: ");
        aliastf=new TextField("");
        keyl=new Label("for key: ");
        keytf=new TextField("");
        add=new Button("add");
        remove=new Button("remove");
        addspecial=new Button("add special key");
        apply=new Button("apply");
        cancel=new Button("cancel");
        dontapply=new Button("don't apply");
        add(info);
        add(l);
        add(aliasl);
        add(aliastf);
        add(keyl);
        add(keytf);
        add(add);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.reshape(10,10,380,27);
        l.reshape(10,40,380,170);
        aliasl.reshape(10,220,80,27);
        aliastf.reshape(110,220,80,27);
        keyl.reshape(210,220,80,27);
        keytf.reshape(310,220,80,27);
        add.reshape(10,250,80,27);
        remove.reshape(110,250,80,27);
        addspecial.reshape(10,280,380,27);
        apply.reshape(10,310,80,27);
        cancel.reshape(210,310,80,27);
        dontapply.reshape(310,310,80,27);
        info.setBackground(Color.white);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public int getKeyCode(int a){
        byte[]by=new byte[1];
        by[0]=(byte)a;
        String s=new String(by);
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(s.equals(alias[i])){
                String sb=key[i];
                byte[]byb=sb.getBytes();
                return byb[0];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.removeAll();
        int n=key.length;
        for(int i=0;i<n;i++){
            if(!special[i]){
                l.addItem(alias[i]+" alias for "+key[i]);
            }
            else{
                byte[]by1=alias[i].getBytes();
                byte[]by2=key[i].getBytes();
                l.addItem("special key "+by1[0]+" alias for "+by2[0]);
            }
        }
    }
    public void loadfirst(){
        try{
            InputStream fis=getInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
            info.setText("keymapforus.ini not found");
        }
    }
    public void load(String filename){
        try{
            InputStream fis=getInputStream(filename);
            DataInputStream dis=new DataInputStream(fis);
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                if("false".equals(inp3)){
                    kmt.add(inp,inp2);
                }
                else{
                    kmt.addspecial(inp,inp2);
                }
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            l.removeAll();
            int n=alias.length;
            for(int i=0;i<n;i++){
                if(!special[i]){
                    l.addItem(alias[i]+" alias for "+key[i]);
                }
                else{
                    byte[]by1=alias[i].getBytes();
                    byte[]by2=key[i].getBytes();
                    l.addItem("special key "+by1[0]+" alias for "+by2[0]);
                }
            }
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.KEY_ACTION||evt.id==Event.KEY_PRESS){
            if(kstatus==1){
                aliasx=evt.key;
                kstatus=2;
                info.setText("type key");
            }
            else if(kstatus==2){
                int keyx=evt.key;
                kstatus=0;
                info.setText("special key added");
                info.setBackground(Color.white);
                byte[]by1=new byte[1];
                by1[0]=(byte)aliasx;
                String s1=new String(by1);
                byte[]by2=new byte[1];
                by2[0]=(byte)keyx;
                String s2=new String(by2);
                kmt.addspecial(s1,s2);
                l.addItem("special key "+((byte)aliasx)+" alias for "+((byte)keyx));
            }
        }
        if(evt.id==Event.ACTION_EVENT){
            if(evt.target==add){
                String a=aliastf.getText();
                String b=keytf.getText();
                if((a.length()!=1)||(b.length()!=1)){
                    info.setText("Error: alias and key must have length 1");
                    return false;
                }
                kmt.add(a,b);
                l.addItem(a+" alias for "+b);
                aliastf.setText("");
                keytf.setText("");
            }
            if(evt.target==remove){
                int ind=l.getSelectedIndex();
                if(ind!=-1){
                    l.remove(ind);
                    kmt.remove(ind);
                }
            }
            if(evt.target==addspecial){
                info.setText("type alias");
                info.setBackground(Color.yellow);
                kstatus=1;
            }
            if(evt.target==apply){
                alias=kmt.alias;
                key=kmt.key;
                special=kmt.special;
                applyb=true;
                closed=true;
                hide();
            }
            if(evt.target==cancel){
                restorekmt();
                cancelb=true;
                closed=true;
                hide();
            }
            if(evt.target==dontapply){
                applyb=false;
                info.setText("KeyboardMapper isn't applied");
            }
        }
        return false;
    }
}
class KeyMapperTable{
    String[]alias=new String[0];
    String[]key=new String[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new String[0];
        key=new String[0];
        special=new boolean[0];
    }
    public void add(String a,String b){
        int n=alias.length;
        String[]aliasb=new String[n+1];
        String[]keyb=new String[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        aliasb[n]=a;
        keyb[n]=b;
        specialb[n]=false;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        String[]aliasb=new String[n+1];
        String[]keyb=new String[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        aliasb[n]=a;
        keyb[n]=b;
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            String[]aliasb=new String[n-1];
            String[]keyb=new String[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
